<script setup lang="ts" generic="T extends GeolocalisableItem & ListableItem">
    import { onMounted, onUnmounted, watch, computed } from 'vue'
    import 'leaflet/dist/leaflet.css'
    import L, { LatLngExpression, ZoomPanOptions, Marker } from 'leaflet'
    import markerIconUrl from 'leaflet/dist/images/marker-icon.png'
    import markerIconRetinaUrl from 'leaflet/dist/images/marker-icon-2x.png'
    import markerShadowUrl from 'leaflet/dist/images/marker-shadow.png'
    import { GestureHandling } from 'leaflet-gesture-handling'
    import 'leaflet-gesture-handling/dist/leaflet-gesture-handling.css'
    import 'leaflet.markercluster/dist/MarkerCluster.css'
    import 'leaflet.markercluster/dist/MarkerCluster.Default.css'
    import 'leaflet.markercluster'
    import { GeolocalisableItem } from '@/elusServiceOffer/entities/GeolocalisableItem'
    import { useRouter } from 'vue-router'
    import { ListableItem } from '@/shared/item/entities/ListableItem'
    import { useDisplay } from 'vuetify/lib/framework.mjs'

    interface Props {
        id?: string
        items: Array<T>
        viewOptions?: {
            center: LatLngExpression
            zoom?: number
            options?: ZoomPanOptions
            maxZoom?: number
        }
        preventDrag?: boolean
        itemSelected?: T
    }

    const router = useRouter()

    const defaultViewOptions = { zoom: 18, maxZoom: 22 }

    const props = withDefaults(defineProps<Props>(), {
        viewOptions: () => {
            return { center: [46.58, 0.34], zoom: 10 }
        },
        id: () => 'mapViewerContainer-' + self.crypto.randomUUID(),
        preventDrag: false,
        itemSelected: undefined,
    })
    const emit = defineEmits(['update:itemSelected'])

    const itemSelected = computed({
        get() {
            return props.itemSelected
        },
        set(item) {
            emit('update:itemSelected', item)
        },
    })

    let geolocationWatchHandlerId: null | number = null
    const objectsMarkerGroup = L.markerClusterGroup({})
    const objectsAndCurrentLocationMarkerGroup = L.featureGroup([
        objectsMarkerGroup,
    ])

    function generateMarkerAltFromId(id?: string) {
        return `map-marker-object-${id}`
    }
    let map: L.Map
    let tileLayerStandard: L.TileLayer
    let tileLayerOrthophotography: L.TileLayer

    watch(itemSelected, () => {
        objectsMarkerGroup.getLayers().forEach((marker) => {
            if (
                marker instanceof Marker &&
                marker.options.alt ===
                    generateMarkerAltFromId(itemSelected.value?.getItemId())
            ) {
                marker.openPopup()
            }
        })
    })

    function updateObjectsMarkers() {
        objectsMarkerGroup.clearLayers()
        props.items.forEach((item) => {
            const itemCoordinates = item.getCoordinates()
            if (itemCoordinates) {
                const marker = L.marker(itemCoordinates, {
                    alt: generateMarkerAltFromId(item.getItemId()),
                })

                let popupContent = `<h2 data-cy="map-marker-object-title-${item.getItemId()}">${item.getItemTitle()}</h2>`

                const itemRoute = item.getItemRoute()
                popupContent = itemRoute
                    ? `<a data-cy="map-marker-object-link-${item.getItemId()}" href="${
                          router.resolve(itemRoute).href
                      }">${popupContent}</a>`
                    : popupContent

                const itemDescription = item.getItemDescription()
                popupContent = itemDescription
                    ? `${popupContent}<p data-cy="map-marker-object-description-${item.getItemId()}">${itemDescription}</p>`
                    : popupContent

                marker.bindPopup(popupContent).openPopup()

                marker.on('popupopen', () => {
                    itemSelected.value = item
                })
                marker.on('popupclose', () => {
                    itemSelected.value = undefined
                })

                objectsMarkerGroup.addLayer(marker)
            }
        })
        objectsMarkerGroup.refreshClusters()
    }

    function createMap() {
        L.Icon.Default.imagePath = ''

        L.Icon.Default.mergeOptions({
            iconUrl: markerIconUrl,
            iconRetinaUrl: markerIconRetinaUrl,
            shadowUrl: markerShadowUrl,
        })

        L.Map.addInitHook('addHandler', 'gestureHandling', GestureHandling)
        const mapOptions: L.MapOptions & { gestureHandling: boolean } = {
            ...defaultViewOptions,
            gestureHandling: props.preventDrag,
            zoomControl: false,
        }

        map = L.map(props.id, mapOptions).setView(
            props.viewOptions.center,
            props.viewOptions.zoom,
            props.viewOptions.options
        )

        objectsAndCurrentLocationMarkerGroup.addTo(map)

        map.attributionControl.setPrefix(false)

        tileLayerStandard = L.tileLayer(
            import.meta.env.VITE_MAP_STANDARD_TILE_LAYER_URL,
            {
                attribution: 'SIG © Grand Poitiers',
                maxZoom: mapOptions.maxZoom,
            }
        ).addTo(map)

        tileLayerOrthophotography = L.tileLayer.wms(
            import.meta.env.VITE_MAP_SATELLITE_TILE_LAYER_URL,
            {
                layers: '0',
                format: 'image/jpeg',
                transparent: false,
                attribution: 'SIG © Grand Poitiers',
                maxZoom: mapOptions.maxZoom,
            }
        )

        const baseLayers = {
            'Vue Standard': tileLayerStandard,
            'Vue Satellite': tileLayerOrthophotography,
        }

        const layersControl = L.control.layers(baseLayers).addTo(map)
        const layersControlContainer = layersControl.getContainer()

        const { smAndDown } = useDisplay()

        if (smAndDown.value && layersControlContainer) {
            layersControlContainer.classList.add('leaflet-control-layers')
            layersControlContainer.style.marginTop = '70px'
        }

        tileLayerStandard.addTo(map)

        map.on('zoomstart', () => {
            if (map.hasLayer(tileLayerOrthophotography)) {
                map.doubleClickZoom.disable()
            }
        })

        map.on('zoomend', () => {
            map.doubleClickZoom.enable()
        })
    }

    function deleteMapIfExists() {
        if (geolocationWatchHandlerId !== null) {
            navigator.geolocation.clearWatch(geolocationWatchHandlerId)
        }
        if (map) {
            map.remove()
        }
    }

    const { smAndDown } = useDisplay()

    function fitBoundsIfPossible() {
        const paddingValue = smAndDown.value ? -120 : 40

        if (objectsAndCurrentLocationMarkerGroup.getBounds().isValid()) {
            map.fitBounds(objectsAndCurrentLocationMarkerGroup.getBounds(), {
                padding: [paddingValue, paddingValue],
            })
        }
    }

    watch(itemSelected, () => {
        const selectedItem = props.items.find(
            (item) => item.getItemId() === props.itemSelected?.getItemId()
        )
        if (selectedItem) {
            objectsMarkerGroup.getLayers().forEach((marker) => {
                if (
                    marker instanceof Marker &&
                    marker.options.alt ===
                        generateMarkerAltFromId(selectedItem?.getItemId())
                ) {
                    map.flyTo(marker.getLatLng(), 18, {
                        animate: true,
                        duration: 0.5,
                    })
                    // setTimeout(() => {
                    //     marker.openPopup()
                    // }, 750)
                }
            })
        }
    })

    onMounted(() => {
        createMap()
        watch(
            () => props.items,
            () => {
                updateObjectsMarkers()
                fitBoundsIfPossible()
            },
            { immediate: true }
        )
    })

    onUnmounted(() => {
        deleteMapIfExists()
    })
</script>

<template>
    <div :id="id"></div>
</template>
